      subroutine fortran_routine
      implicit none
c This include has definitions of the common block and declarations for
c variables it contains.
      include 'fortran_variables.h'

      integer i, j, k

      print*, 'now in FORTRAN'
      print*,''
c Try and print out the various values of the elements in the shared
c structure/common-block
      print*, 'variables ---------------------'
      print*, ' boolean value', value_bool
      print*, ' int value', value_int
      print*, ' real value', value_float
      print*, ' real*8 value', value_double
      print*, ' vector'
      do i=1,5
          print*,i, value_vector(i)
      enddo
      print*, ' matrix'
      do i=1,2
         do j=1,4
            print*,i,j, value_matrix(i,j)
         enddo
      enddo
      
c Now, from Fortran, write to the variables, and see how they turn up in
c C++ when read from structure
      print*, 'Setting variables from Fortran'
      value_bool=.TRUE.
      value_int=12345
      value_float=1.23
      value_double=5.67
      do i=1,5
          value_vector(i)=i-1
      enddo
      print*, ' matrix'
      do i=1,2
         do j=1,4
            value_matrix(i,j)=(i-1)*4+(j-1)
         enddo
      enddo

      end
